'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _haselementsininterval = require('oncoprintjs/src/js/haselementsininterval');

var _haselementsininterval2 = _interopRequireDefault(_haselementsininterval);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// PrecomputedComparator is similar to the OncoPrintJs implementation with
// three notable changes: rewritten with Flow/ES next and as a class, the input
// data structure is different, and no direction.
var PrecomputedComparator = function () {
  function PrecomputedComparator(data, comparator) {
    _classCallCheck(this, PrecomputedComparator);

    this.comparator = comparator;
    this.data = data;

    this.sort();
  }

  _createClass(PrecomputedComparator, [{
    key: 'sort',
    value: function sort() {
      this.sortedData = this.data.sort(this.comparator);

      this.changePoints = [];
      for (var i = 0; i < this.sortedData.length; i += 1) {
        if (i === this.sortedData.length - 1) {
          break;
        }

        if (this.comparator(this.sortedData[i], this.sortedData[i + 1]) !== 0) {
          this.changePoints.push(i);
        }
      }

      this.samplesToIndex = {};
      for (var _i = 0; _i < this.sortedData.length; _i += 1) {
        this.samplesToIndex[this.sortedData[_i]] = _i;
      }
    }
  }, {
    key: 'compare',
    value: function compare(s1, s2) {
      var i1 = this.samplesToIndex[s1];
      var i2 = this.samplesToIndex[s2];

      if (typeof i1 === 'undefined' && typeof i2 === 'undefined') {
        return 0;
      } else if (typeof i1 === 'undefined') {
        return 1;
      } else if (typeof i2 === 'undefined') {
        return -1;
      }

      var shouldNegateResult = false;

      if (i1 === i2) {
        return 0;
      } else if (i1 > i2) {
        var tmp = i1;
        i1 = i2;
        i2 = tmp;
        shouldNegateResult = true;
      }

      var res = 0;
      if ((0, _haselementsininterval2.default)(this.changePoints, function (x) {
        return x;
      }, i1, i2)) {
        res = -1;
      }

      if (shouldNegateResult) {
        res *= -1;
      }

      return res;
    }
  }]);

  return PrecomputedComparator;
}();

exports.default = PrecomputedComparator;