'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lib = require('../lib');

var _dataset = require('./data/dataset1.json');

var _dataset2 = _interopRequireDefault(_dataset);

var _dataset3 = require('./data/dataset2.json');

var _dataset4 = _interopRequireDefault(_dataset3);

var _dataset5 = require('./data/dataset3.json');

var _dataset6 = _interopRequireDefault(_dataset5);

var _cBioPortalData = require('./data/cBioPortalData.json');

var _cBioPortalData2 = _interopRequireDefault(_cBioPortalData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DATA = {
    dataset1: _dataset2.default,
    dataset2: _dataset4.default,
    dataset3: _dataset6.default,
    cBioPortalData: _cBioPortalData2.default
};

var App = function (_Component) {
    _inherits(App, _Component);

    function App(props) {
        _classCallCheck(this, App);

        var _this = _possibleConstructorReturn(this, (App.__proto__ || Object.getPrototypeOf(App)).call(this, props));

        _this.state = {
            value: 'dataset3',
            events: []
        };
        _this.setProps = _this.setProps.bind(_this);
        _this.handleDataChange = _this.handleDataChange.bind(_this);
        _this.handlePlotChange = _this.handlePlotChange.bind(_this);
        return _this;
    }

    _createClass(App, [{
        key: 'setProps',
        value: function setProps(newProps) {
            this.setState(newProps);
        }
    }, {
        key: 'handleDataChange',
        value: function handleDataChange(event) {
            this.setState({ value: event.target.value });
        }
    }, {
        key: 'handlePlotChange',
        value: function handlePlotChange(event) {
            var events = this.state.events;
            events.unshift(JSON.stringify(event));
            this.setState({ events: events });
        }
    }, {
        key: 'render',
        value: function render() {
            var _state = this.state,
                value = _state.value,
                events = _state.events;


            return _react2.default.createElement(
                'div',
                {
                    style: {
                        fontFamily: ["helvetica", "sans-serif"],
                        padding: 16,
                        background: "#F5F5F5"
                    }
                },
                _react2.default.createElement(
                    'h1',
                    null,
                    'dash-oncoprint Demo'
                ),
                _react2.default.createElement(
                    'div',
                    {
                        style: {
                            padding: 16,
                            marginBottom: 32,
                            background: "#FFFFFF"
                        }
                    },
                    _react2.default.createElement(
                        'p',
                        null,
                        'Selected file: ',
                        value + '.js'
                    ),
                    _react2.default.createElement(
                        'select',
                        { value: value, onChange: this.handleDataChange, style: { width: '100%' } },
                        _react2.default.createElement(
                            'option',
                            { value: 'dataset1' },
                            'Small dataset'
                        ),
                        _react2.default.createElement(
                            'option',
                            { value: 'dataset2' },
                            'Medium dataset'
                        ),
                        _react2.default.createElement(
                            'option',
                            { value: 'dataset3' },
                            'Large dataset'
                        ),
                        _react2.default.createElement(
                            'option',
                            { value: 'cBioPortalData' },
                            'CBioPortal Dataset'
                        )
                    )
                ),
                _react2.default.createElement(
                    'div',
                    { style: { height: 500 } },
                    _react2.default.createElement(_lib.OncoPrint, {
                        data: DATA[value],
                        onChange: this.handlePlotChange
                    })
                ),
                _react2.default.createElement(
                    'div',
                    {
                        style: {
                            padding: 16,
                            marginTop: 32,
                            background: "#FFFFFF"
                        }
                    },
                    _react2.default.createElement(
                        'p',
                        null,
                        'Events:'
                    ),
                    _react2.default.createElement('textarea', {
                        style: {
                            width: '100%',
                            height: 200,
                            fontSize: '14px'
                        },
                        value: events.join('\n')
                    })
                )
            );
        }
    }]);

    return App;
}(_react.Component);

exports.default = App;